## golang-github-apache-arrow-go 18.1.0

=== debian/changelog ===
golang-github-apache-arrow-go (18.1.0-2) unstable; urgency=medium

  * Standards-Version: 4.7.2.
  * Build on more archs on Salsa.
  * Add upstream 32-bit arch fix.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 05 Mar 2025 20:25:35 +0100

golang-github-apache-arrow-go (18.1.0-1) unstable; urgency=medium

  * Initial release (Closes: #1095753)

 -- Simon Josefsson <simon@josefsson.org>  Tue, 11 Feb 2025 17:57:29 +0100
