=== debian/changelog ===
golang-github-apache-arrow-go (18.2.0-1) unstable; urgency=medium

  * d/salsa-ci: Build rdeps.
  * New upstream version 18.2.0
  * Drop upstreamed patch.
  * d/copyright: Drop safe-math.h special (gone upstream).
  * docs: Add NOTICE.txt.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 10 Apr 2025 02:11:43 +0200
