=== debian/control ===
Source: golang-github-apache-arrow-go
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-google-flatbuffers-dev,
 golang-github-stretchr-testify-dev,
 golang-golang-x-exp-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-xerrors-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-apache-arrow-go
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-apache-arrow-go.git
Homepage: https://github.com/apache/arrow-go
XS-Go-Import-Path: github.com/apache/arrow-go/v18

Package: golang-github-apache-arrow-go-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: toolbox for data interchange and in-memory analytics (Go library)
 Apache Arrow (https://arrow.apache.org) is a cross-language development
 platform for in-memory data. It specifies a standardized language-
 independent columnar memory format for flat and hierarchical data,
 organized for efficient analytic operations on modern hardware. It also
 provides computational libraries and zero-copy streaming messaging and
 inter-process communication.
 .
 This package contains the Go development library.
