=== debian/rules ===
#!/usr/bin/make -f

# strip down this package to suite golang-github-gorgonia-tensor,
# since this package needs a lot of unpackaged build dependencies
export DH_GOLANG_BUILDPKG := \
	github.com/apache/arrow-go/v18/arrow/bitutil \
	github.com/apache/arrow-go/v18/arrow/endian \
	github.com/apache/arrow-go/v18/arrow/internal/debug \
	github.com/apache/arrow-go/v18/arrow/memory

%:
	dh $@ --builddirectory=_build --buildsystem=golang
